///home/berryj/link/bin/genMethods "-g" "-t" "int" "-h" "Set" "-r" "MSet<int>" "-I" "LINK/basic/Set.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/Set.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef int _int;
typedef Set<int > _Set_int_;
static Set<int > s__Set_int_;

#define _Set_int_DATA(x) ((Set<int >*) (EXTDATA(x)))
#define _Set_int_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<int > >::type))
#define _Set_int_ISNT_DATA(x) (!_Set_int_IS_DATA(x))

#define _Set_int_CXX_DATA(x) (*(Set<int >*) (EXTDATA(VAL(x))))
#define _Set_int_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<int > >::type))
#define _Set_int_CXX_ISNT_DATA(x) (!_Set_int_CXX_IS_DATA(x))


PRIMITIVE STk_init__Set_int_()
{
	Wrapper<_Set_int_>::type = STk_new_CXXwrapper_id(
			Wrapper<_Set_int_>::name, 
			Wrapper<MSet<int> >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_int>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_int>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_int>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Set_int_>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Set_int_Methods(void);

PRIMITIVE STk_init_methods__Set_int_()
{
	genExtra_Set_int_Methods();
	return UNDEFINED;
}
